Offers List API

The Offers List API paginates the list of eligible offers for a context combination and ensures the sequence of those offers on each page and the order of pages remain the same for every run of the getOffers API.

The ctxEligibilityCacheKey must be passed in the request body of this API. You can obtain the ctxEligibilityCacheKey required in the request body from the apiResponse.eligibilityContextKey node in the response body of the Context Eligibility API.

Precondition 

You must first the Context Eligibility API to obtain the ctxEligibilityCacheKey required in the request body of this API.

URI 

/services/apexrest/{namespace}/v3/admin/catalogs/{catalogCode}/offers

HTTP Method 

POST

URI Parameters 

If you specify just one of these two parameters, it follows the behavior described in the table below and accepts your defined time for the parameter you specified. If you are using one or both parameters, you must specify them with the same values for all of the Populate Cache APIs in this sequence.

ParameterExampleDefaultOptional/RequiredNotes
effectiveStartTime2001-07-04T12:08:56Current date and timeOptionaleffectiveStartTime is the time that you want your cached catalog entries to be effective. It should be in the UTC date-time format. Your effectiveStartTime must occur after the current time for which you are executing the Populate Cache APIs or you will receive an error message.
expirationTime2001-07-04T12:08:56effectiveStartTime + TimeToLiveOptionalexpirationTime is the time that you want your cached catalog entries to expire. It should also be in the UTC date-time format. Your expirationTime must occur after your effectiveStartTime or you receive an error message. TimeToLive is a custom setting created in CPQ Configuration Setup. It has a default value of 30 days.

Here is an example of how to pass the URI parameters:

1GET /services/apexrest/vlocity_cmt/v3/admin/catalogs/AS-Test-Catalog/offers?effectiveStartTime=2021-07-04T12:08:56&expirationTime=2021-08-04T12:08:56

Request Body Parameters 

ParameterData TypeDescriptionDefaultOptional/Required
ctxEligibilityCacheKeyStringCache key pointing to the context eligibility record to sort and paginate.N/ARequired

Sample Request Body 

This is a sample request for a context eligibility cache key (ctxEligibilityCacheKey).

1{
2    "ctxEligibilityCacheKey": "418744a77cd0344bcc501f2ed72aa920"
3}

Remote API 

This is an example of how you invoke the API using Apex:

1String methodName;
2String requestBodyJSON;
3Map<String, Object> input = new Map<String, Object>();
4Map<String, Object> output = new Map<String, Object>();
5Map<String, Object> options = new Map<String, Object>();
6
7// Setting remote parameters
8methodName = 'getOffers';
9requestBodyJSON = '{"ctxEligibilityCacheKey":"418744a77cd0344bcc501f2ed72aa920"}';
10input.put('apiName','CMOffers'); //required
11input.put('catalogCode', 'TestCatalog');    //required
12input.put('effectiveStartTime', null);      //optional
13input.put('expirationTime', null);          //optional
14input.put('requestBody', requestBodyJSON);  //required
15input.put('methodName',methodName);         //required
16input.put('requestURL', '/v3/admin/catalogs/TestCatalog/offers'); //required
17
18//remote action invocation
19vlocity_cmt.CpqAppHandler appHandler = new vlocity_cmt.CpqAppHandler();
20appHandler.invokeMethod(methodName, input, output, options);

Parallel Invocation 

Each context eligibility result can be processed in parallel. For example, if there are 10 catalogs and each catalog links to 12 context eligibility results, then all 120 results can run in parallel.

1THREAD1 -  POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog1/offers
2THREAD2 -  POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog1/offers
3...
4THREAD12 - POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog1/offers
5THREAD13 - POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog2/offers
6......
7THREAD120 - POST /services/apexrest/{namespace}/v3/admin/catalogs/catalog10/offers

HTTP Headers 

HeaderDescription
Content-Typeapplication/json

Response Body 

This example shows a list of eligible offers for a context combination in the correct sequence and order of pages.

1{
2  "nextOffersAction": {
3    "rest": {
4      "params": {},
5      "method": "GET",
6      "link": "/v3/catalogs/T9_cache_mgmt/offers?context={\"DIM_0\":\"V_0_2\",\"DIM_1\":\"V_1_1\",\"DIM_2\":\"V_2_2\",\"DIM_3\":\"V_3_1\",\"DIM_4\":\"V_4_2\"}&offset=100&pagesize=20"
7    },
8    "remote": {
9      "params": {}
10    },
11    "client": {
12      "records": [],
13      "params": {}
14    }
15  },
16  "result": {
17    "Promotion": [
18      "a3T5g000000CvcvEAC",
19      "a3T5g000000Cvd0EAC",
20      "a3T5g000000Cvd1EAC"
21    ],
22    "Product": [
23      "01t5g000002vVUIAA2",
24      "01t5g000002vVUJAA2",
25      "01t5g000002vVUKAA2",
26      "01t5g000002vVULAA2",
27      "01t5g000002vVUMAA2",
28      "01t5g000002vVUNAA2",
29      "01t5g000002vVUOAA2",
30      "01t5g000002vVUPAA2",
31      "01t5g000002vVUQAA2",
32      "01t5g000002vVURAA2",
33      "01t5g000002vVUSAA2",
34      "01t5g000002vVUTAA2",
35      "01t5g000002vVUUAA2",
36      "01t5g000002vVUVAA2",
37      "01t5g000002vVUWAA2",
38      "01t5g000002vVUXAA2",
39      "01t5g000002vVUYAA2"
40    ]
41  }
42}

HTTP Response Codes 

CodeDescription
200OK
500Internal Server Error